/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-turtle-actionlib-0.1.7-0precise-20150329-2032/obj-x86_64-linux-gnu/devel/share/turtle_actionlib/msg/ShapeResult.msg
 *
 */


#ifndef TURTLE_ACTIONLIB_MESSAGE_SHAPERESULT_H
#define TURTLE_ACTIONLIB_MESSAGE_SHAPERESULT_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace turtle_actionlib
{
template <class ContainerAllocator>
struct ShapeResult_
{
  typedef ShapeResult_<ContainerAllocator> Type;

  ShapeResult_()
    : interior_angle(0.0)
    , apothem(0.0)  {
    }
  ShapeResult_(const ContainerAllocator& _alloc)
    : interior_angle(0.0)
    , apothem(0.0)  {
    }



   typedef float _interior_angle_type;
  _interior_angle_type interior_angle;

   typedef float _apothem_type;
  _apothem_type apothem;




  typedef boost::shared_ptr< ::turtle_actionlib::ShapeResult_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::turtle_actionlib::ShapeResult_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct ShapeResult_

typedef ::turtle_actionlib::ShapeResult_<std::allocator<void> > ShapeResult;

typedef boost::shared_ptr< ::turtle_actionlib::ShapeResult > ShapeResultPtr;
typedef boost::shared_ptr< ::turtle_actionlib::ShapeResult const> ShapeResultConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::turtle_actionlib::ShapeResult_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::turtle_actionlib::ShapeResult_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace turtle_actionlib

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'actionlib_msgs': ['/opt/ros/hydro/share/actionlib_msgs/cmake/../msg'], 'turtle_actionlib': ['/tmp/buildd/ros-hydro-turtle-actionlib-0.1.7-0precise-20150329-2032/msg', '/tmp/buildd/ros-hydro-turtle-actionlib-0.1.7-0precise-20150329-2032/obj-x86_64-linux-gnu/devel/share/turtle_actionlib/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::turtle_actionlib::ShapeResult_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::turtle_actionlib::ShapeResult_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::turtle_actionlib::ShapeResult_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::turtle_actionlib::ShapeResult_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::turtle_actionlib::ShapeResult_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::turtle_actionlib::ShapeResult_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::turtle_actionlib::ShapeResult_<ContainerAllocator> >
{
  static const char* value()
  {
    return "b06c6e2225f820dbc644270387cd1a7c";
  }

  static const char* value(const ::turtle_actionlib::ShapeResult_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xb06c6e2225f820dbULL;
  static const uint64_t static_value2 = 0xc644270387cd1a7cULL;
};

template<class ContainerAllocator>
struct DataType< ::turtle_actionlib::ShapeResult_<ContainerAllocator> >
{
  static const char* value()
  {
    return "turtle_actionlib/ShapeResult";
  }

  static const char* value(const ::turtle_actionlib::ShapeResult_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::turtle_actionlib::ShapeResult_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======\n\
#result definition\n\
float32 interior_angle\n\
float32 apothem\n\
";
  }

  static const char* value(const ::turtle_actionlib::ShapeResult_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::turtle_actionlib::ShapeResult_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.interior_angle);
      stream.next(m.apothem);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct ShapeResult_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::turtle_actionlib::ShapeResult_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::turtle_actionlib::ShapeResult_<ContainerAllocator>& v)
  {
    s << indent << "interior_angle: ";
    Printer<float>::stream(s, indent + "  ", v.interior_angle);
    s << indent << "apothem: ";
    Printer<float>::stream(s, indent + "  ", v.apothem);
  }
};

} // namespace message_operations
} // namespace ros

#endif // TURTLE_ACTIONLIB_MESSAGE_SHAPERESULT_H
